<!--
 * @Author: lb
 * @Date: 2022-06-22 14:00:17
 * @LastEditors: lb
 * @LastEditTime: 2022-06-22 14:00:17
 * @Description: 设备生产实时数据
-->
<template>
	<div>
		<div class="app-container">
			<small-title :size="'md'">{{ $t('realtime.eq') }}</small-title>
			<base-table v-if="loadTable" :table-head-configs="tableProps" :data="tableData.length ? tableData : []" :span-method="spanMethod" />
		</div>
	</div>
</template>

<script>
import i18n from '@/i18n'
import BaseTable from '@/components/base-table'
import SmallTitle from '@/components/small-title'
import moment from 'moment'
import { calcMaxHeight } from '@/utils'
import { timeFilter } from '@/utils/filters'
export default {
	name: 'RealtimeDataOfEquipment',
	components: { BaseTable, SmallTitle },
	data() {
		return {
			calcMaxHeight,
			loadTable: false,
			tableProps: [{ label: 'default', prop: 'default' }],
			stepOneArray: [],
			tableData: [],
			testData: null,
			equipmentCount: {}, // 每个产线的设备数量记录
			dynamicPropSet: false, // 是否设置过动态prop
			listLoading: false,
			rowNum: 0,
			intervalId: null
		}
	},
	created() {
		this.clearData()
		this.fetchList().then(({ data: res }) => {
			this.testData = res.data.filter(item => !!item.equDet)
			this.handleData()
		})
		this.intervalId = setInterval(() => {
			this.$message({
				message: this.$t('realtime.refresh'),
				type: 'warning',
				duration: 1500,
				onClose: () => {
					this.clearData()
					this.fetchList().then(({ data: res }) => {
						this.testData = res.data.filter(item => !!item.equDet)
						this.handleData()
					})
				}
			})
		}, 1000 * 60 * 5)
	},
	// beforeDestroy() {
	// 	console.log('before destroyed...')
	// 	if (this.intervalId) clearInterval(this.intervalId)
	// },
	deactivated() {
		if (this.intervalId) clearInterval(this.intervalId)
	},
	methods: {
		clearData() {
			this.tableData.splice(0)
			this.tableProps.splice(0)
			this.stepOneArray.splice(0)
			this.dynamicPropSet = false
			this.rowNum = 0
			this.testData = null
			this.loadTable = false
			this.equipmentCount = {}
			this.setStaticTableProps()
		},

		handleData() {
			this.expandDataStepOne()
			this.expandDataStepTwo()
			this.loadTable = true
		},

		fetchList() {
			// 获取设备实时数据
			return this.$http({
				url: this.$http.adornUrl('/monitoring/productionMonitoring/equipmentProductionRealTimeData'),
				method: 'post'
			})
		},

		expandDataStepOne() {
			// console.log('testdata: ', this.testData)
			this.stepOneArray = this.testData.map(item => {
				if (item.equDet) {
					item.equDet.forEach((equipment, index) => {
						equipment.lineName = item.lineName
					})
				}
				return item.equDet
			})
		},

		expandDataStepTwo() {
			// 扩展服务器返回的数据第二阶段
			this.rowNum = 0

			this.stepOneArray.forEach(line => {
				let avaliableEquipmentCount = 0

				line.forEach(equipment => {
					const newItem = {
						equId: equipment.equId,
						lineName: equipment.lineName,
						equName: equipment.equName,
						externalCode: equipment.externalCode,
						totalProduction: equipment.totalProduction ?? '-'
					}

					if (equipment.det) {
						avaliableEquipmentCount += 1
						equipment.det.forEach(obj => {
							if (!this.dynamicPropSet) {
								if (obj.recordTime) {
									// 如果 obj.recordTime 是有效的
									this.tableProps.push({
										label: moment(obj.recordTime).format('YYYY-MM-DD HH:mm:ss'),
										children: [
											{ prop: obj.recordTime + '-inputNum', label: i18n.t('realtime.in') },
											{ prop: obj.recordTime + '-outputNum', label: i18n.t('realtime.out') },
											{ prop: obj.recordTime + '-scrapNum', label: i18n.t('realtime.data') },
											{ prop: obj.recordTime + '-scrapRate', label: i18n.t('realtime.rate'), filter: val => (val !== '-' ? `${val.toFixed(2)}%` : '-') }
										]
									})
								}
							}

							Object.defineProperty(newItem, obj.recordTime + '-inputNum', {
								value: obj.inputNum ?? '-',
								enumerable: true,
								writable: true
							})
							Object.defineProperty(newItem, obj.recordTime + '-outputNum', {
								value: obj.outputNum ?? '-',
								enumerable: true,
								writable: true
							})
							Object.defineProperty(newItem, obj.recordTime + '-scrapNum', {
								value: obj.scrapNum ?? '-',
								enumerable: true,
								writable: true
							})
							Object.defineProperty(newItem, obj.recordTime + '-scrapRate', {
								value: obj.scrapRate ?? '-',
								enumerable: true,
								writable: true
							})
							Object.defineProperty(newItem, 'recordTime', {
								value: obj.recordTime,
								enumerable: true,
								writable: true
							})
						})

						if (!this.dynamicPropSet) this.dynamicPropSet = true
						this.tableData.push(newItem)
					}
				})
				this.$set(this.equipmentCount, [this.rowNum], avaliableEquipmentCount)
				this.rowNum += avaliableEquipmentCount
			})
		},

		setStaticTableProps() {
			// Step1: 设置静态的 table props
			const staticTableProps = [
				{ prop: 'lineName', label: i18n.t('pl.title'), fixed: true },
				{ prop: 'equName', label: i18n.t('equipment'), fixed: true },
				{ prop: 'totalProduction', label: i18n.t('realtime.total'), fixed: true }
			]
			this.tableProps = staticTableProps
		},

		spanMethod({ row, column, rowIndex, columnIndex }) {
			// 设置合并行列的方式
			if (columnIndex === 0) {
				if (this.equipmentCount[rowIndex]) {
					// 如果找到需要合并的行号
					return {
						rowspan: this.equipmentCount[rowIndex],
						colspan: 1
					}
				} else {
					return {
						rowspan: 0,
						colspan: 0
					}
				}
			}
		}
	}
}
</script>
